## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 6;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond check 1
%bcond heif %{undefined rhel}
%bcond jpegxl %{undefined rhel}

%if 0%{?rhel}
%global bundled_rust_deps 1
%else
%global bundled_rust_deps 0
%endif

%global tarball_version %%(echo %{version} | tr '~' '.')

Name:           glycin-loaders
Version:        1.0.1
Release:        %autorelease
Summary:        Sandboxed image rendering

# (Apache-2.0 OR MIT) AND BSD-3-Clause
# (MIT OR Apache-2.0) AND Unicode-DFS-2016
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# BSD-2-Clause
# GPL-3.0-or-later
# LGPL-2.1-or-later
# MIT
# MIT OR Apache-2.0
# MIT OR Apache-2.0 OR Zlib
# MIT OR Zlib OR Apache-2.0
# MPL-2.0
# MPL-2.0 OR LGPL-2.1-or-later
# Unlicense OR MIT
# Zlib OR Apache-2.0 OR MIT
License:        Apache-2.0 AND BSD-2-Clause AND BSD-3-Clause AND GPL-3.0-or-later AND LGPL-2.1-or-later AND MIT AND MPL-2.0 AND Unicode-DFS-2016 AND (Apache-2.0 OR MIT) AND (0BSD OR MIT OR Apache-2.0) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND (MIT OR Apache-2.0 OR Zlib) AND (MPL-2.0 OR LGPL-2.1-or-later) AND (Unlicense OR MIT)
# LICENSE.dependencies contains a full license breakdown
URL:            https://gitlab.gnome.org/sophie-h/glycin
Source0:        https://download.gnome.org/sources/glycin-loaders/1.0/glycin-loaders-%{tarball_version}.tar.xz

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

%if 0%{?rhel}
BuildRequires:  rust-toolset
%else
BuildRequires:  cargo-rpm-macros
%endif
BuildRequires:  git-core
BuildRequires:  meson
BuildRequires:  pkgconfig(gtk4)
BuildRequires:  pkgconfig(libseccomp)
%if %{with heif}
BuildRequires:  pkgconfig(libheif)
%endif
%if %{with jpegxl}
BuildRequires:  pkgconfig(libjxl)
%endif
BuildRequires:  pkgconfig(cairo)

%description
Sandboxed and extendable image decoding.


%prep
%autosetup -p1 -n glycin-loaders-%{tarball_version}

%if 0%{?bundled_rust_deps}
%cargo_prep -v vendor
%else
rm -rf vendor
%cargo_prep
%endif


%if ! 0%{?bundled_rust_deps}
%generate_buildrequires
%cargo_generate_buildrequires
%endif


%build
%meson \
  -Dloaders=%{?with_heif:glycin-heif,}glycin-image-rs,%{?with_jpegxl:glycin-jxl,}glycin-svg \
  -Dtest_skip_install=true \
  %{nil}

%meson_build

%cargo_license_summary
%{cargo_license} > LICENSE.dependencies
%if 0%{?bundled_rust_deps}
%cargo_vendor_manifest
%endif


%install
%meson_install


%if %{with check}
%check
# Something is wrong with the test setup and tests fail with
# "No such file or directory"
%meson_test || :
%endif


%files
%license LICENSE LICENSE-LGPL-2.1 LICENSE-MPL-2.0
%license LICENSE.dependencies
%if 0%{?bundled_rust_deps}
%license cargo-vendor.txt
%endif
%doc NEWS README.md
%{_libexecdir}/glycin-loaders/
%{_datadir}/glycin-loaders/


%changelog
* Sun Sep 01 2024 Fabio Valentini <decathorpe@gmail.com> - 1.0.1-6
- Re-enable OpenEXR support

* Thu Jul 18 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Fri May 24 2024 Fabio Valentini <decathorpe@gmail.com> - 1.0.1-4
- Rebuild with Rust 1.78 to fix incomplete debuginfo and backtraces

* Tue Apr 09 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1.0.1-3
- Disable jpegxl loader in RHEL builds

* Thu Apr 04 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1.0.1-2
- Add library dependencies

* Tue Apr 02 2024 Fabio Valentini <decathorpe@gmail.com> - 1.0.1-1
- Update to version 1.0.1; Fixes RHBZ#2272614

* Thu Feb 01 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 0.1.2-4
- Update Rust macro usage

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Tue Nov 14 2023 Kalev Lember <klember@redhat.com> - 0.1.2-1
- Update to 0.1.2

* Tue Nov 14 2023 Kalev Lember <klember@redhat.com> - 0.1.1-7
- Update license tag for dependencies

* Tue Nov 14 2023 Kalev Lember <klember@redhat.com> - 0.1.1-6
- Enable glycin-jxl loader

* Mon Nov 13 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 0.1.1-5
- Fix RHEL build

* Thu Nov 09 2023 Kalev Lember <klember@redhat.com> - 0.1.1-4
- Enable glycin-heif loader

* Sun Oct 01 2023 Kalev Lember <klember@redhat.com> - 0.1.1-3
- Drop downstream patch to use librsvg pre-release version

* Thu Sep 21 2023 Kalev Lember <klember@redhat.com> - 0.1.1-2
- Enable heif support now that rust-libheif-rs is packaged

* Tue Sep 19 2023 Fabio Valentini <decathorpe@gmail.com> - 0.1.1-1
- Update to version 0.1.1

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> - 0.1~rc-4
- ExcludeArch i686 for
  https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> - 0.1~rc-3
- Skip install during self tests

* Thu Sep 07 2023 Kalev Lember <klember@redhat.com> - 0.1~rc-2
- Use bundled rust deps on RHEL

* Wed Sep 06 2023 Kalev Lember <klember@redhat.com> - 0.1~rc-1
- Update to 0.1.rc

* Wed Aug 23 2023 Kalev Lember <klember@redhat.com> - 0.1~beta.4-2
- Enable qoi support now that it's available in rust-image

* Wed Aug 23 2023 Kalev Lember <klember@redhat.com> - 0.1~beta.4-1
- Update to 0.1.0-beta.4
- Upstream relicensed to 'MPL-2.0 OR LGPL-2.1-or-later'

* Tue Aug 22 2023 Kalev Lember <klember@redhat.com> - 0.1~beta.3-3
- Re-enable tests, but ignore the results for now

* Tue Aug 22 2023 Kalev Lember <klember@redhat.com> - 0.1~beta.3-2
- Temorarily disable tests

* Tue Aug 22 2023 Kalev Lember <klember@redhat.com> - 0.1~beta.3-1
- Update to 0.1.beta.3

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 0.1~beta.2-2
- Update the license tag to reflect the licenses of all rust dependencies
- Use LGPL-2.1-only for the project license until we get confirmation from
  upstream

* Mon Aug 21 2023 Kalev Lember <klember@redhat.com> - 0.1~beta.2-1
- Initial Fedora packaging (rhbz#2233278)
